unit Unit1;

{  essential Pascal: voorbeeld #3 : analyse kikkersprongen spel

   2 groepjes van 3 kikkers (X en Y) zitten tegenover elkaar
   X X X - Y Y Y
   een X kikker springt
     - naar open plaats direct rechts
     - over andere kikker naar open plaats rechts
   een Y kikker springt
     - naar open plaats direct links
     - over andere kikker naar open plaats links

   codering:
     - speelveld : array[1..6] of Tveld = (leeg, Xkikker,Ykikker)
     - sprong    : van veld org naar veld dest

   algemeen:
     k X en k Y kikkers, dus speelveld 2*k + 1 velden
     totaal afgelegde velden = 2k(k+1)   elke kikker legt k+1 velden af
     aantal dubbele sprongen = k*k ----> 2k*k velden
     aantal enkele sprongen  = 2k(k+1) - 2k*k = 2k
     totaal aantal sprongen  = k*k + 2k = k(k+2)  maximaal...indien oplossing

   oplossing zoeken:
     per veld is hoogstens 1 sprong mogelijk.
     een (sprong) keuze is dus gelijk aan het veldnummer 1..2k+1
     een oplossing bestaat uit een reeks veldkeuzen bv. 3 5 6 5 2 1 3 5 ......
     zoeken naar een oplossing is systematisch doorlopen van alle veldkeuzen
     bv van [1111....] tot [777777....] igv 2 * 3 kikkers
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    StaticText1: TStaticText;
    Label1: TLabel;
    kikkersUpDown: TUpDown;
    PaintBox1: TPaintBox;
    clearBtn: TBitBtn;
    replayBtn: TSpeedButton;
    analyseBtn: TSpeedButton;
    goBtn: TBitBtn;
    msgLabel: TLabel;
    playBtn: TSpeedButton;
    procedure kikkersUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure goBtnClick(Sender: TObject);
    procedure analyseBtnClick(Sender: TObject);
    procedure replayBtnClick(Sender: TObject);
    procedure playBtnClick(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type Tkikkersoort = (geen,kX,kY);    //soort kikker
     Tsprong      = record
                     org  : byte;    //van veld nr
                     dest : byte;    //naar ..  ..
                    end;

const maxkikker = 10;                //max 2*10+1 = 21 velden
      maxsprong  = maxkikker*(maxkikker+2);
      maxveld    = 2*maxkikker+1;
      backgroundcolor = $f0ffff;

var speelveld : array[1..maxveld] of Tkikkersoort;
    sprongen  : array[1..maxsprong] of Tsprong;
    sprongNr  : byte;   //sprong nummer
    replayNr : byte;
    gemarkeerd: byte = 0; //gemarkeerd veld in play-mode

procedure tekenVeld(nr : byte);
//verwijder kikker / voeg kikker toe op speelveld
var r : trect;
    c : char;
    x,y : integer;
begin
 r.Left := (nr-1) * 20 + 1;
 r.Right := r.left + 18;
 r.top := 1;
 r.Bottom := r.Top + 28;
 with form1.PaintBox1 do with Canvas do
  begin
   font.Name := 'arial';
   font.Height := 20;
   font.Style := [fsBold];
   brush.Color := backgroundcolor;
   fillrect(r);
    case speelveld[nr] of
     geen : c := '_';
     kX   : c := 'X';
     kY   : c := 'Y';
    end;
   brush.style := bsClear;
   x := 20*nr  - 10 - textwidth(c) div 2;
   y := (height - textheight(c)) div 2;
   textout(x,y,c);
  end;
end;

procedure markeerveld(nr : byte);
//plaats oranje rechthoekje in veld
var x1,x2 : integer;
begin
 with form1.paintbox1.canvas do
  begin
   pen.width := 2;
   pen.color := $0080ff;
   x1 := (nr-1) * 20 + 2;
   x2 := nr * 20 - 2;
   brush.style := bsClear;
   rectangle(x1,3,x2,28);
  end;
end;

procedure kikkersOpstellen;
//beginsituatie instellen
var i,k : byte;
begin
 k := form1.kikkersUpdown.position;
 for i := 1 to k do
  begin
   speelveld[i] := kX;
   speelveld[k+1+i] := kY;
  end;
 speelveld[k+1] := geen;  //geen kikker
 for i := 1 to 2*k+1 do tekenVeld(i);
end;

procedure WisOplossing;
//sprongen verwijderen
var i : byte;
begin
 for i := 1 to maxsprong do
  begin
   sprongen[i].org := 0;
   sprongen[i].dest := 0;
  end;
 sprongNr := 0;
end;

function sprongOK(nr : byte) : byte;
//is sprong mogelijk van kikker in veld nr?
//geen sprong : result = 0
//wel sprong  : result = destination veld
var i,code,w : byte;
begin
 result := 0;
 if speelveld[nr] = geen then exit;

 w := 2*Form1.kikkersUpDown.position + 1; //aantal velden
 case speelveld[nr] of
  kX   : code := $10;
  kY   : code := $20;
 end;

 for i := 1 to w do
  if speelveld[i] = geen then  //als veld leeg is...
   case i - nr of
    -2 : code := code or 8;
    -1 : code := code or 4;
     1 : code := code or 1;
     2 : code := code or 2;
   end;
 case code of
  $11 : result := nr+1;
  $12 : result := nr+2;
  $24 : result := nr-1;
  $28 : result := nr-2;
 end;
end;

function TestOpVeld(x,y : integer) : byte;
//vertaal x,y muiscordinaten naar veld
//geen veld: result = 0
begin
 if (x mod 20 > 3) and (x mod 20 < 18) and (y > 3) and (y < 28) then
  result := (x div 20) + 1 else result := 0;
end;

procedure maaksprong(naar,van : byte);
begin
 speelveld[naar] := speelveld[van];
 speelveld[van] := geen;
 tekenveld(naar);
 tekenveld(van);
end;

procedure voegzettoe(naar,van : byte);
begin
 inc(sprongNr);
 sprongen[sprongNr].org := van;
 sprongen[sprongNr].dest := naar;
end;

function zoekOplossing : boolean;
//return true als oplossing gevonden
var i,k,van,naar,w : byte;
label sprong1,testsprong,volgveld;
begin
 k := form1.kikkersUpDown.position;
 w := 2*k + 1;

sprong1:

 van := 1;

testsprong:

 naar := sprongOK(van);
 if naar = 0 then goto volgveld;
 speelveld[naar] := speelveld[van];
 speelveld[van] := geen;
 inc(sprongNr);
 sprongen[sprongNr].org := van;
 sprongen[sprongNr].dest := naar;

 i := 1;
 if speelveld[k+1] = geen then
  begin
   while (speelveld[i] = kY) and (i <= k) do inc(i);
   if i = k+1 then
    begin
     result := true;
     exit;
    end;
  end  
  else goto sprong1;

volgveld:

 inc(van);
 if van <= w then goto testsprong;

 if sprongNr > 0 then               //spring terug
  begin
   naar := sprongen[sprongNr].dest;
   van  := sprongen[sprongNr].org;
   speelveld[van] := speelveld[naar];
   speelveld[naar] := geen;
   dec(sprongNr);
   goto volgveld;
  end
  else result := false;
end;

procedure TForm1.kikkersUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 paintbox1.Invalidate; //teken spel met nieuwe afmetingen
 kikkersOpstellen;
 sprongNr := 0;
 replayNr := 0;

end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var i,w : byte;
begin
 w := kikkersUpDown.position * 2 + 1;
 with paintbox1 do with canvas do
  begin
   width := w*20;
   pen.Width := 1;
   pen.color := $c0;
   brush.Color := backgroundcolor;
   rectangle(0,0,width,height);
  end;
 for i := 1 to w do tekenveld(i);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 kikkersUpDown.position := 3;
 kikkersOpstellen;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
begin
 kikkersOpstellen;
 if replayBtn.Down then replayNr := 1
  else wisOplossing;
 msgLabel.Caption := ''; 
end;

procedure TForm1.goBtnClick(Sender: TObject);
var van,naar : byte;
begin
 if playbtn.down then
  if sprongNr > 0 then
   begin                               //neem laatste zet terug
    van := sprongen[sprongNr].org;
    naar := sprongen[sprongNr].dest;
    speelveld[van] := speelveld[naar];
    speelveld[naar] := geen;
    tekenveld(van);
    tekenveld(naar);
    dec(sprongNr);
    if sprongNr > 0 then msglabel.Caption := 'sprong '+inttostr(sprongNr)
     else msgLabel.Caption := 'beginstand bereikt';
   end;

 if analyseBtn.Down then
  begin                  //find solution
   if zoekoplossing then
    msgLabel.caption := 'oplossing in '+inttostr(sprongNr)+' zetten'
    else  msglabel.caption := 'geen oplossing';
  end;

 if replayBtn.Down then
  begin                 //step through solution
   if replayNr <= sprongNr then
    begin
     msglabel.Caption := 'sprong '+ inttostr(replayNr);
     maaksprong(sprongen[replayNr].dest,sprongen[replayNr].org);
     inc(replayNr);
    end
    else msglabel.Caption := 'laatste sprong bereikt';; 
  end;
end;

procedure TForm1.analyseBtnClick(Sender: TObject);
begin
 goBtn.Caption := 'go';
end;

procedure TForm1.replayBtnClick(Sender: TObject);
begin
 goBtn.Caption := 'step';
 replayNr := 1;
 kikkersopstellen;
end;

procedure TForm1.playBtnClick(Sender: TObject);
begin
 goBtn.caption := 'terug';
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
//exit als niet in "play" mode
//markeer aangewezen veld
var veld : byte;
begin
 if playBtn.Down = false then exit;
 if shift <> [] then exit;

 veld := testOpVeld(x,y);
 if veld <> gemarkeerd then
  begin
   if gemarkeerd <> 0 then tekenveld(gemarkeerd);
   if (veld <> 0) and (sprongOK(veld) > 0) then markeerveld(veld);
   gemarkeerd := veld;
  end;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//doe een zet in "play" mode
var dest : byte;
begin
 if playBtn.Down = false then exit;
 if gemarkeerd <> 0 then
  begin
   dest := sprongOK(gemarkeerd);
   if dest <> 0 then
    begin
     maaksprong(dest,gemarkeerd);
     voegzettoe(dest,gemarkeerd);
     gemarkeerd := 0;
     msgLabel.Caption := 'sprong '+ inttostr(sprongNr);
    end; 
  end;
end;

end.
 